Unit VOCER;

Interface

Const
  vocOk         =  0;
  vocLoadDriver = -1;
  vocLoadVOC    = -2;

Var
  VocResult,
  CT_VOICE  : Integer;                          { > 0 while sound is playing }

Procedure LoadVOC (Name : String; Var P : Pointer; Var Size : Word);

Function InitDriver : Word;

Procedure SetPort (Port : Word);

Procedure SetDMA (DMA : Word);

Function GetVer : Word;

Procedure DefineStatusWord;

Procedure DoneDriver;

Procedure SpeakerOff;

Procedure SpeakerOn;

Function StartSound (Var Sound) : Word;

Procedure StopSound;

Function PauseSound : Word;

Function ContinueSound : Word;

Function BreakSound (How : Word) : Word;

Implementation

Var
  F : File;
  DrvPtr  : Pointer;    { Driver must starts at the begining of paragraph! }
  DrvSize : Word;

Procedure LoadVOC (Name : String; Var P : Pointer; Var Size : Word);
Var
  F : File;
Begin
  VocResult := vocOk;
  Filemode := 0;
  Assign (F, Name);
  {$I-} Reset (F, 1); {$I+}
  If IOResult <> 0 then Begin
    VocResult := vocLoadVOC;
    P := Nil;
    Size := 0;
    FileMode := 2;
    Exit
  End;
  Size := FileSize (F);
  GetMem (P, Size);
  BlockRead (F, P^, Size);
  Close (F);
  FileMode := 2
End;

Function InitDriver : Word; Assembler;
Asm
  Mov   BX, 3
  Call  DWord Ptr DrvPtr
End;

Procedure SetPort (Port : Word); Assembler;
Asm
  Mov   BX, 1
  Mov   AX, Port
  Call  DWord Ptr DrvPtr
End;

Procedure SetDMA (DMA : Word); Assembler;
Asm
  Mov   BX, 2
  Mov   AX, DMA
  Call  DWord Ptr DrvPtr
End;

Function GetVer : Word; Assembler;
Asm
  Xor   BX, BX
  Call  DWord Ptr DrvPtr
End;

Procedure DefineStatusWord; Assembler;
Asm
  Mov   BX, 5
  Mov   DI, Offset CT_VOICE
  Mov   AX, Seg CT_VOICE
  Mov   ES, AX
  Call  DWord Ptr DrvPtr
End;

Procedure DoneDriver;
Begin
  Asm
    Mov   BX, 9
    Call  DWord Ptr DrvPtr
  End;
  FreeMem (DrvPtr, DrvSize)
End;

Procedure SpeakerOff; Assembler;
Asm
  Mov   BX, 4
  Mov   AX, 0
  Call  DWord Ptr DrvPtr
End;

Procedure SpeakerOn; Assembler;
Asm
  Mov   BX, 4
  Mov   AX, 1
  Call  DWord Ptr DrvPtr
End;

Function StartSound (Var Sound) : Word; Assembler;
Asm
  Mov   BX, 6
  LES   DI, Sound
  Mov   AL, ES:[DI+20]
  Xor   AH, AH
  Add   DI, AX
  Call  DWord Ptr DrvPtr
End;

Procedure StopSound; Assembler;
Asm
  Mov   BX, 8
  Call  DWord Ptr DrvPtr
End;

Function PauseSound : Word; Assembler;
Asm
  Mov   BX, 10
  Call  DWord Ptr DrvPtr
End;

Function ContinueSound : Word; Assembler;
Asm
  Mov   BX, 11
  Call  DWord Ptr DrvPtr
End;

Function BreakSound (How : Word) : Word; Assembler;
Asm
  Mov   BX, 12
  Mov   AX, How
  Call  DWord Ptr DrvPtr
End;

Begin
  FileMode := 0;
  Assign (F, 'CT-VOICE.DRV');
  {$I-} Reset (F, 1); {$I+}
  VocResult := IOResult;
  If VocResult=0 then Begin
    DrvSize := FileSize (F);
    GetMem (DrvPtr, DrvSize);
    BlockRead (F, DrvPtr^, DrvSize);
    Close (F)
  End
  Else Begin
    VocResult := vocLoadDriver;
    DrvPtr := Nil;
    DrvSize := 0
  End;
  FileMode := 2
End.
